/**	\file Application.h
 **	\date  2008-05-26
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2008-2009  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _Application_H
#define _Application_H

#include <string>
#include <map>


class Application
{
public:
	Application(int argc, char *argv[]);
	~Application();

	const std::string& Filename() const { return m_filename; }
	const std::string& Portname() const { return m_portname; }
	const std::string& Namespace() const { return m_global_ns; }
	const std::string& Classname() const { return m_classname; }
	const std::string& ListType() const { return m_lt; }
	const std::string& ToDir() const { return m_todir; }

	bool Overwrite() const { return m_overwrite; }

	FILE *myfopen(const std::string& filename, const std::string& mode);

	const std::string Href2Prefix(const std::string& ns_href) const;

private:
	std::string m_filename;
	std::string m_portname;
	std::string m_global_ns;
	std::string m_classname;
	std::string m_lt;
	bool m_overwrite;
	std::map<std::string, std::string> m_nsmap;
	std::string m_todir;
};




#endif // _Application_H
