/**	\file Attribute.h
 **	\date  2008-05-26
 **	\author grymse@alhem.net
**/
/*
Copyright (C) 2008-2009  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#ifndef _Attribute_H
#define _Attribute_H

#include <string>
#include <list>
#include "TypeBase.h"

class Wsdl;

class Attribute : public TypeBase
{
public:
	Attribute(const Wsdl& wsdl, const XmlNode& node, const std::string& name = "", const std::string& ns_prefix = "");
	~Attribute();

	const std::string& Name() const { return m_name; }
	const std::string& BaseType() const { return m_base_type; }
	const std::string Documentation() const;

	const std::string CType() const;
	const std::string CName() const;
	const std::string CName1up() const;

	bool IsOptional() const;
	bool IsSimpleType() const;

	const std::string CType_decl() const;
	const std::string CType_in() const;
	const std::string CType_out() const;
	const std::string DefaultValue() const;

	bool DefaultIsSet() const { return m_b_default_is_set; }
	bool FixedIsSet() const { return m_b_fixed_is_set; }

	const std::string& Default() const { return m_default; }
	const std::string& Fixed() const { return m_fixed; }

private:
	std::string m_name;
	std::string m_base_type;
	std::string m_use;
	std::string m_default;
	bool m_b_default_is_set;
	std::string m_fixed;
	bool m_b_fixed_is_set;
};




#endif // _Attribute_H
