const std::string Wsdl::NamespaceFromHref(const std::string& href) const
{
	size_t pos = href.find("://");
	if (pos != std::string::npos)
	{
		std::string hreft = href.substr(pos + 3);
		pos = hreft.find("/");
		std::string host = hreft;
		std::string path;
		if (pos != std::string::npos)
		{
			host = hreft.substr(0, pos);
			path = hreft.substr(pos + 1);
		}
		Parse pa(host, ".:");
		std::string tmp = pa.getword();
		std::string ns;
		std::string ns2;
		while (!tmp.empty())
		{
			ns = ns2;
			ns2 = tmp + "_" + ns2;
			tmp = pa.getword();
		}
		for (size_t i = 0; i < path.size(); i++)
			if (isalnum(path[i]))
				ns += path[i];
			else
				ns += "_";
		return ns;
	}
	Parse pa(href, ":");
	std::string tmp = pa.getword();
	std::string ns;
	while (!tmp.empty())
	{
		if (!ns.empty())
			ns += "_";
		ns += tmp;
		tmp = pa.getword();
	}
	return ns;
}


const std::string Wsdl::NamespaceFromPrefix(const std::string& prefix) const
{
	XmlNode root(m_doc);
	std::string href = root.GetNsMap()[prefix];
	return NamespaceFromHref(href);
}


